




<!DOCTYPE html>
<html>
<head>
<title>关于C++ 中 thread 的拷贝构造函数 -  码上快乐</title>
<meta name="keywords" content="" />
<meta name="description" content="起因来自于 C 并发编程实战 的这样一个例子 nbsp 我 灵机一动 ，将main函数变成了这个亚子： 编译器毫不犹豫的给我报错了： 一个是先定义了一个thread对象t ，然后用将t 作为参数传入scropethread的构造函数，一个是定义了一个临时的thread对象，然后将其传入scropet" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<meta http-equiv="Cache-Control" content="no-transform" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<meta name="applicable-device" content="pc,mobile">
<link href="/css/all.css?version=" rel="stylesheet">
<link href="/css/prettify.css?version=" rel="stylesheet">
</head>
<body onload="prettyPrint()">
    
<style>
.div2{top:45px;z-index:999;position:fixed;_position:absolute}
</style>
<div class="navbar navbar-inverse navbar-fixed-top">
	<div class="navbar-inner">
		<div class="container">
			<button data-target=".nav-collapse" data-toggle="collapse" class="btn btn-navbar" type="button">
				<span class="icon-bar"></span> 
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<a class="brand" href="/index.html">码上快乐</a>
			<div class="nav-collapse collapse">
                <p class="navbar-text pull-right toplogin" style="margin-top:0px;">
	              <a href="javascript:void(0)" class="btn-show-login navbar-link">1秒登录</a>
	            </p>		
				<ul class="nav">
					<li class="navtop index"><a href="/index.html"><i class="icon-home icon-white"></i><strong>首页</strong></a></li>
					<li class="navtop recent"><a href="/rank.html"><i class="icon-fire icon-white"></i><strong>榜单</strong></a></li>
					<li class="navtop tags"><a href="/tags.html"><i class="icon-tag icon-white"></i><strong>标签</strong></a></li>
					<li class="navtop hot"><a href="/about.html"><i class="icon-heart icon-white"></i><strong>关于</strong></a></li>
					<li class="navtop hot"><a href="javascript:void(0);" rel="nofollow"><i class="icon-fire icon-white"></i><strong style="color:red" class="gptclass"></strong></a></li>
				</ul>
			</div>
		</div>
	</div>
</div>
<script src="/js/all.js?version="></script>

<!-- Global site tag (gtag.js) - Google Analytics -->

    <input name="ua" value="" type="hidden"/>
    <input name="title" value="关于C++ 中 thread 的拷贝构造函数" type="hidden"/>
	<div class="container" style="padding-top:20px;">
		<div class="row-fluid m_b_20">
		    
			<div class="span2 visible-desktop" id="logo">
				<center>
					<a href="/index.html"><img src="/img/logo.png?version=" class="h_30"/></a>
				</center>
			</div>
			<div class="span6">
				<form class="form-search" action="/so" name="search-form">
					<div class="input-append span10">
						<center>
							<input type="text" class="span12 search-query" name="q" placeholder=" 请输入关键词搜索..." baiduSug="1">
							<button type="submit" class="btn btn-warning">搜索</button>
						</center>
					</div>
				</form>
			</div>
			<div class="span4 visible-desktop">
			    <a class="btn" href="/recommend/acf2e61/关于C-中-thread-的拷贝构造函数"><i class="icon-random"></i>相关内容</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/blog/acf2e61.html"><i class="icon-refresh"></i>简体</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/zh/blog/acf2e61.html"><i class="icon-refresh"></i>繁体</a>
				
			</div>
		</div>
		<div class="row-fluid">
		    
			<div class="span8">
			    <div class="content_div">
			      <center>
			      <h3><a href="/blog/acf2e61.html" style="color:black">关于C++ 中 thread 的拷贝构造函数</a></h3>
			      </center>
			      <div class="postinfo">
			              本文转载自
			      
			      <i class="icon-globe"></i>&nbsp;<a href="/go/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vWGlhb1hpYW9TaHVhaS0vcC8xMTMzNDM3NC5odG1s" target="_blank">查看原文</a>
			      <i class="icon-time"></i>&nbsp;<span>2019-08-11 11:27</span>
			      <i class="icon-eye-open"></i>&nbsp;<span>397&nbsp;</span>
                  
                  <i class="icon-star" title="1.0977"></i>
                  
                  
                  
                                    
			      </div>
			      <hr/>
                 <div class="media-body" id="content_div">
                    <div class="title_down_ad ad">
					</div>
					<div class="post_content" id="postContent">
					  <p>起因来自于《C++并发编程实战》的这样一个例子</p> 
<div class="cnblogs_code"> 
 <pre>#include &lt;thread&gt;<span style="color: #000000;">
#include </span>&lt;iostream&gt;<span style="color: #000000;">
#include </span>&lt;stdexcept&gt;

<span style="color: #0000ff;">class</span><span style="color: #000000;"> ScropeThread
{
</span><span style="color: #0000ff;">public</span><span style="color: #000000;">:
    ScropeThread(std::thread t) :m_pThead(std::move(t))
    {
        </span><span style="color: #0000ff;">if</span> (!<span style="color: #000000;">m_pThead.joinable())
        {
            </span><span style="color: #0000ff;">throw</span> std::logic_error(<span style="color: #800000;">"</span><span style="color: #800000;">no thread</span><span style="color: #800000;">"</span><span style="color: #000000;">);
        }
    }
    </span>~<span style="color: #000000;">ScropeThread()
    {
        m_pThead.join();
    }
    ScropeThread(</span><span style="color: #0000ff;">const</span> ScropeThread &amp;) = <span style="color: #0000ff;">delete</span><span style="color: #000000;">;
    ScropeThread</span>&amp; <span style="color: #0000ff;">operator</span>=(<span style="color: #0000ff;">const</span> ScropeThread &amp;) = <span style="color: #0000ff;">delete</span><span style="color: #000000;">;

</span><span style="color: #0000ff;">private</span><span style="color: #000000;">:
    std::thread m_pThead;
};

</span><span style="color: #0000ff;">void</span> fun(<span style="color: #0000ff;">void</span><span style="color: #000000;">){}
</span><span style="color: #0000ff;">int</span><span style="color: #000000;"> main()
{
    ScropeThread(std::thread(fun));

    </span><span style="color: #0000ff;">return</span> <span style="color: #800080;">0</span><span style="color: #000000;">;
}</span></pre> 
</div> 
<p>&nbsp;</p> 
<p>我“灵机一动”，将main函数变成了这个亚子：</p> 
<div class="cnblogs_code"> 
 <pre><span style="color: #0000ff;">int</span><span style="color: #000000;"> main()
{
    std::thread t1(fun);
    ScropeThread st(t1);

    </span><span style="color: #0000ff;">return</span> <span style="color: #800080;">0</span><span style="color: #000000;">;
}</span></pre> 
</div> 
<p>编译器毫不犹豫的给我报错了：</p> 
<p><img src="/image/aHR0cHM6Ly9pbWcyMDE4LmNuYmxvZ3MuY29tL2Jsb2cvMTUyNTg1MC8yMDE5MDgvMTUyNTg1MC0yMDE5MDgxMTExMDgwNTcyMy01Mjg5MDEzMTkucG5n.png" alt="" referrerpolicy="no-referrer"></p> 
<p>一个是先定义了一个thread对象t1，然后用将t1作为参数传入scropethread的构造函数，一个是定义了一个临时的thread对象，然后将其传入scropethread的参数列表。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>这两种方法<strong>都需要利用拷贝构造函数将实参拷贝给形参</strong>，即这<strong>两种方法都用到了thread类的拷贝构造函数</strong>。</p> 
<p>报错的原因用人话来说就是thread类没有定义拷贝构造函数。我百思不得其解。</p> 
<p>折腾了快两个小时。突然福至心灵，想到了c++中<strong>右值</strong>的概念。对哟，以第一种方式将参数传入scropethread的构造函数时，我在参数列表里建立了一个<strong>临时的</strong>&nbsp;std::thread(fun)，这是一个<strong>右值</strong>。</p> 
<p>而当我在外面这样定义时：&nbsp;std::thread t1(fun);t1是一个<strong>左值</strong>。</p> 
<p>而错误的真正原因是：<strong>thread类没有定义以左值作为参数的拷贝构造函数，但却有以右值作为参数的拷贝构造函数。</strong></p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>点进thread类的头文件，果然如此：</p> 
<p><img src="/image/aHR0cHM6Ly9pbWcyMDE4LmNuYmxvZ3MuY29tL2Jsb2cvMTUyNTg1MC8yMDE5MDgvMTUyNTg1MC0yMDE5MDgxMTExMjMxNTA1Ny04NjYzMDY1ODkucG5n.png" alt="" referrerpolicy="no-referrer"></p> 
<p>从头文件中，我们也可以得出一个结论：<strong>thread对象是不能复制（copy）的，只能移动（move）</strong>。</p>
					</div>      
                    <div class="read-more" id="read-more" style="display:none"></div>        
                    <div class="alert alert-info" style="margin-top:20px;">
				      <p id="tips_top1">
				      </p>
			        </div>
			        <script type="text/javascript">
			         $("#tips_top1").append("<strong><i class=\"icon-fire\"></i>温馨提示：</strong>如果本文未解决您的问题，可以免费向大模型提问：<strong><a href='javascript:void(0)' class='gptbtn'>向AI大模型提问</a></strong>。");
			        </script>				        
					<div class="iframe-container">
					</div>
                 </div>
                 
			      
			      <div class="ad_content_down ad">
			      </div>                 
			    </div>
			     
			     <div class="disclaimer visible-desktop">
			         <br/>
		             <div class="alert alert-block">
		              <button type="button" class="close" data-dismiss="alert">×</button>
		              <h4>免责声明！</h4>
		                 <p>本站转载的文章为个人学习借鉴使用，本站对版权不负任何法律责任。如果侵犯了您的隐私权益，请联系本站邮箱yoyou2525@163.com删除。</p>
		            </div>	
		            <br/><br/>
                 </div>
			</div>
			
			<!-- 右边相关博客和资料 -->
			<div class="span4 left_content">
			  <div id="left_list_div" class="left_content">
			   <span class="list-group-item" href="javascript:void(0)"><i class="icon-filter"></i><strong>猜您在找</strong></span>
			   
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/b8ae421.html" title="C++中的拷贝构造函数">
			           
			           <i class="icon-file"></i>
			           C++中的拷贝构造函数
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/2654e11.html" title="C++中拷贝构造函数">
			           
			           <i class="icon-file"></i>
			           C++中拷贝构造函数
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/37230c1.html" title="C++ 拷贝构造函数和赋值构造函数">
			           <i class="icon-fire"></i>
			           
			           C++ 拷贝构造函数和赋值构造函数
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/75ef061.html" title="C++中构造函数，拷贝构造函数和赋值函数的区别和实现">
			           <i class="icon-fire"></i>
			           
			           C++中构造函数，拷贝构造函数和赋值函数的区别和实现
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/8113f21.html" title="c++拷贝构造函数详解">
			           <i class="icon-fire"></i>
			           
			           c++拷贝构造函数详解
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/3a76181.html" title="c++ 拷贝构造函数 继承">
			           
			           <i class="icon-file"></i>
			           c++ 拷贝构造函数 继承
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/8b94861.html" title="c++之拷贝构造函数详解">
			           <i class="icon-fire"></i>
			           
			           c++之拷贝构造函数详解
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/c0c7921.html" title="关于c++的默认拷贝构造函数">
			           
			           <i class="icon-file"></i>
			           关于c++的默认拷贝构造函数
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/e550541.html" title="C++笔记（5）拷贝构造函数">
			           
			           <i class="icon-file"></i>
			           C++笔记（5）拷贝构造函数
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/9ed71d1.html" title="C++拷贝构造函数">
			           
			           <i class="icon-file"></i>
			           C++拷贝构造函数
			           </a>
			       			       
			   
			   
			   <div id="right_float_ad" class="ad">
				</div>
			</div>
			</div>
		</div>
	</div>
    <div class="clear">&nbsp;</div>
    



<div class="fbar" style="z-index:100">
	<div class="span7" style="color:grey;font-size:12px;">
	</div>
	<div class="pull-right">
		<span><a href="http://beian.miit.gov.cn" rel="nofollow" target="_blank">粤ICP备18138465号</a>&nbsp;&nbsp;</span><span>&copy; 2018-2024 CODEPRJ.COM </span> 
	</div>
</div>
<script src="/js/code.js?version=20240329"></script>
<script>
   function buffer(a, b, c) {
	    var d;
	    return function() {
	        if (d) return;
	        d = setTimeout(function() {
	            a.call(this),
	            d = undefined
	        },
	        b)
	    }
	} 

	(function() {
	    function e() {
	        var d = document.body.scrollTop || document.documentElement.scrollTop;
	        d > b ? (a.className = "div1 div2", c && (a.style.top = d - b + "px")) : a.className = "div1"
	    }
	    var a = document.getElementById("float");
	    if (a == undefined) return ! 1;
	    var b = 0,
	    c, d = a;
	    while (d) b += d.offsetTop,
	    d = d.offsetParent;
	    c = window.ActiveXObject && !window.XMLHttpRequest;
	    if (!c || !0) window.onscroll = buffer(e, 50, this)
	})(); 

</script>

<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?85c5e8e7b6167edfc87cb0607142e870";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

    
    
</body>
</html>